; Target: CC111x
; Purpose: Blink LEDs connected to P1.0 and P1.1 as on the USB dongle (see swru082b.pdf)
;
$NOMOD51

PCON            DATA    087h
P1              DATA    090h
WORIRQ          DATA    0A1h
WORCTRL         DATA    0A2h
WOREVT0         DATA    0A3h
WOREVT1         DATA    0A4h
IEN0            DATA    0A8h
SLEEP           DATA    0BEh
P1DIR           DATA    0FEh
STIF            BIT     0C7h

                CSEG    AT 00000h
                orl     WORCTRL, #004h
                mov     WOREVT1, #043h
                mov     WOREVT0, #0B5h
                mov     SLEEP, #006h
                mov     WORIRQ, #010h
                mov     P1DIR, #003h
                mov     IEN0, #0A0h
Loop:           orl     PCON, #001h
                sjmp    Loop

                CSEG    AT 0002Bh
                clr     STIF
                cpl     P1.0
                jnb     P1.0, Done
                cpl     P1.1
Done:           reti

                END
