#ifndef CAGDIPROGRESS_H
#define CAGDIPROGRESS_H

class CAgdiProgress : public ISmartICE04Progress
{
protected:
    inline IUnknown* GetUnknown() { return(static_cast<ISmartICE04Progress*>(this)); }

public:
    // IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    // ISmartICE04Progress
    STDMETHOD(Start)();
    STDMETHOD(Stop)();
    STDMETHOD(SetProgress)(long lCompleted, long lTotal);
    STDMETHOD(get_Canceled)(VARIANT_BOOL* pblCanceled);

    CAgdiProgress(long lAlreadyDone, long lActualSize, pCBF pCbFunc);
    virtual ~CAgdiProgress();

private:
    ITaskbarList3*  m_pTaskbarList;
    long            m_lAlreadyDone;
    long            m_lActualSize;
    pCBF            m_pCbFunc;
};

#endif
