#ifndef   CCOMEXCEPTION_H
  #define CCOMEXCEPTION_H

    class CComException
    {
      public:
        CComException(IDispatch* pSender, DISPID dispid, HRESULT hr = E_FAIL) throw();
        ~CComException() throw();

        inline HRESULT FromWin32(DWORD dwError) throw() { m_hr = HRESULT_FROM_WIN32(dwError); return(m_hr); }
        inline HRESULT FromSetupApi(DWORD dwError) throw() { m_hr = HRESULT_FROM_SETUPAPI(dwError); return(m_hr); }

        HRESULT m_hr;

      private:
        IDispatch*  m_pSender;
        DISPID      m_dispid;
        
        void Raise(void) throw();
    };

#endif