#ifndef CENUMVARIANT_H
#define CENUMVARIANT_H

class CEnumVARIANT : public IEnumVARIANT
{
public:
    // IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObj);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    // IEnumVARIANT
    STDMETHOD(Next)(THIS_ ULONG celt, VARIANT* rgVar, ULONG* pCeltFetched);
    STDMETHOD(Skip)(THIS_ ULONG celt);
    STDMETHOD(Reset)(THIS);
    STDMETHOD(Clone)(THIS_ IEnumVARIANT** ppEnum);

    CEnumVARIANT(class CSmartICE04Devices* pDevices) throw();

private:
    virtual ~CEnumVARIANT() throw();

    class CSmartICE04Devices*   m_pDevices;
    volatile LONG               m_lCursor;
    ULONG                       m_lRefCount;
    LONG                        m_lLBound;
#ifdef _WIN64
    BYTE bPadding[4];   // C4820
#endif
};

#endif