#include "precomp.h"

CSmartICE04ProgressDummy::CSmartICE04ProgressDummy()
{
    m_pDispatch = this;
}

CSmartICE04ProgressDummy::~CSmartICE04ProgressDummy()
{
    m_pDispatch->Release();
}

STDMETHODIMP
CSmartICE04ProgressDummy::QueryInterface(THIS_ REFIID, void**)
{
    return(E_NOTIMPL);
}

STDMETHODIMP_(ULONG)
CSmartICE04ProgressDummy::AddRef(THIS)
{
    return(2);
}

STDMETHODIMP_(ULONG)
CSmartICE04ProgressDummy::Release(THIS)
{
    return(1);
}

STDMETHODIMP
CSmartICE04ProgressDummy::GetTypeInfoCount(THIS_ UINT*)
{
    return(E_NOTIMPL);
}

STDMETHODIMP
CSmartICE04ProgressDummy::GetTypeInfo(THIS_ UINT, LCID, ITypeInfo**)
{
    return(E_NOTIMPL);
}

STDMETHODIMP
CSmartICE04ProgressDummy::GetIDsOfNames(THIS_ REFIID, LPOLESTR*, UINT, LCID, DISPID*)
{
    return(E_NOTIMPL);
}

STDMETHODIMP
CSmartICE04ProgressDummy::Invoke(DISPID, REFIID, LCID, WORD, DISPPARAMS*, VARIANT*, EXCEPINFO*, UINT*)
{
    return(E_NOTIMPL);
}

STDMETHODIMP
CSmartICE04ProgressDummy::Start(THIS)
{
    return(InvokeMethod(L"Start"));
}

STDMETHODIMP
CSmartICE04ProgressDummy::Stop(THIS)
{
    return(InvokeMethod(L"Stop"));
}

STDMETHODIMP
CSmartICE04ProgressDummy::SetProgress(THIS_ long lCompleted, long lTotal)
{
    VARIANT var[2];

    VariantInit(&var[0]);
    VariantInit(&var[1]);

    V_VT(&var[0]) = VT_I4;
    V_I4(&var[0]) = lTotal;
    V_VT(&var[1]) = VT_I4;
    V_I4(&var[1]) = lCompleted;

    return(InvokeMethod(L"SetProgress", var, 2));
}

STDMETHODIMP
CSmartICE04ProgressDummy::get_Canceled(THIS_ VARIANT_BOOL* pblCanceled)
{
    return(GetProperty(L"Canceled", pblCanceled));
}

VOID
CSmartICE04ProgressDummy::SetDispatch(IDispatch* pDispatch)
{
    m_pDispatch->Release();
    m_pDispatch = (pDispatch) ? pDispatch : this;
    m_pDispatch->AddRef();
}

HRESULT
CSmartICE04ProgressDummy::GetProperty(LPWSTR pwszName, VARIANT *rgvarg)
{
    DISPPARAMS  dispparams;
    HRESULT     hr;
    DISPID      dispid;

    VariantInit(rgvarg);

    if(SUCCEEDED((hr = m_pDispatch->GetIDsOfNames(IID_NULL, &pwszName, 1, CThreadLocale::getLCID(), &dispid))))
    {
        dispparams.rgvarg               = NULL;
        dispparams.rgdispidNamedArgs    = NULL;
        dispparams.cArgs                = 0;
        dispparams.cNamedArgs           = 0;
        hr = m_pDispatch->Invoke(dispid, IID_NULL, CThreadLocale::getLCID(), DISPATCH_PROPERTYGET, &dispparams, rgvarg, NULL, NULL);
    }

    return(hr);
}

HRESULT
CSmartICE04ProgressDummy::GetProperty(LPWSTR pwszName, VARIANT_BOOL *pval)
{
    HRESULT hr;
    VARIANT var;

    VariantInit(&var);

    if(FAILED((hr = GetProperty(pwszName, &var))))
        return(hr);

    if(SUCCEEDED((hr = VariantChangeTypeEx(&var, &var, CThreadLocale::getLCID(), 0, VT_BOOL))))
        *pval = V_BOOL(&var);

    VariantClear(&var);
    return(hr);
}

HRESULT
CSmartICE04ProgressDummy::InvokeMethod(LPWSTR pwszName, VARIANT *rgvarg /* = NULL */, UINT cArgs /* = 1 */, VARIANT *pVarResult /* = NULL */)
{
    DISPPARAMS  dispparams;
    HRESULT     hr;
    DISPID      dispid;

    if(SUCCEEDED((hr = m_pDispatch->GetIDsOfNames(IID_NULL, &pwszName, 1, CThreadLocale::getLCID(), &dispid))))
    {
        dispparams.rgvarg               = rgvarg;
        dispparams.rgdispidNamedArgs    = 0;
        dispparams.cArgs                = (rgvarg) ? cArgs : 0;
        dispparams.cNamedArgs           = 0;
        hr = m_pDispatch->Invoke(dispid, IID_NULL, CThreadLocale::getLCID(), DISPATCH_METHOD, &dispparams, pVarResult, NULL, NULL);
    }

    return(hr);
}
