#ifndef CTARGETSETUP_H
#define CTARGETSETUP_H

class CTargetSetup
{
public:
    static HRESULT DoModal(HWND hWndParent);

    void AddDevice(ISmartICE04* pDevice);
    void RemoveDevice(ISmartICE04* pDevice);

private:
    CTargetSetup() throw();
    ~CTargetSetup() throw();

    INT_PTR OnWmInitDialog(HWND hWnd, WPARAM wParam, LPARAM lParam);
    INT_PTR OnWmCommand(HWND hWnd, WPARAM wParam, LPARAM lParam);

    static INT_PTR CALLBACK DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
    HWND    m_hWnd;
    CSmartICE04DevicesEventsSinkT<CTargetSetup> m_Sink;
};

#endif