#ifndef CTHREADLOCALE_H
#define CTHREADLOCALE_H

class CThreadLocale
{
public:
    CThreadLocale(LCID lcid) : m_lcid(GetThreadLocale()) { SetThreadLocale(lcid); }
    ~CThreadLocale() { SetThreadLocale(m_lcid); }

    static inline LCID    getLCID(void)   { return(GetThreadLocale());          }
    static inline LANGID  getLANGID(void) { return(LANGIDFROMLCID(getLCID()));  }

private:
    LCID m_lcid;
};

#endif
