#ifndef PRECOMP_H
#define PRECOMP_H

#define _WIN32_WINNT 0x0501
#define _CRT_SECURE_NO_WARNINGS
#define _IN_TARG_                   // define if used within target

#pragma warning(disable: 4514)
#pragma warning(disable: 4710)
#pragma warning(disable: 4711)
#pragma warning(push)
#pragma warning(disable: 4201)
#pragma warning(disable: 4668)
#pragma warning(disable: 4820)
#pragma warning(disable: 4917)
#pragma warning(disable: 6387)

#include <windows.h>
#include <tchar.h>
#include <new>
#include <setupapi.h>
#include <dbt.h>
#include <shlobj.h>
#include <devguid.h>
#include <oleauto.h>
#include <shlwapi.h>
#include <cassert>
#include <cstdio>
#include <OleCtl.h>
#include <Uxtheme.h>
#include <cerrno>

extern "C" {
#include <hidsdi.h>
}

#include "AGDI.H"
#include "BOM.H"
#include "COMTYP.H"
#include "COLLECT.H"
#include "ioCC1111.h"

#pragma warning(pop)

#include <SmartICE04.h>

#include "resource.h"
#include "errmsg.h"
#include "globals.h"
#include "misc.h"
#include "DllMain.h"
#include "RegisterDescriptions.h"
#include "CThreadLocale.h"
#include "selfreg.h"
#include "CList.h"
#include "CActCtx.h"
#include "ComException.h"
#include "CSmartICE04DevicesEventsSink.h"
#include "CDownloadSetup.h"
#include "CTargetSetup.h"
#include "CDeviceList.h"
#include "CSmartICE04EventsSink.h"
#include "CAgdiProgress.h"
#include "CClassFactory.h"
#include "CConnectionPoint.h"
#include "CEnumVARIANT.h"
#include "CEnumConnectionPoints.h"
#include "CEnumConnections.h"
#include "CSmartICE04Progress.h"
#include "CSmartICE04ProgressDialog.h"
#include "CSmartICE04ProgressDummy.h"
#include "CSmartICE04Events.h"
#include "CDSmartICE04Events.h"
#include "CSmartICE04.h"
#include "CSmartICE04DevicesEvents.h"
#include "CDSmartICE04DevicesEvents.h"
#include "CSmartICE04Devices.h"
#include "CBinaryFile.h"
#include "CIntelHexFile.h"

#endif