#pragma warning(disable: 4514)
#pragma warning(disable: 4711)
#pragma warning(push)
#pragma warning(disable: 4668)
#pragma warning(disable: 4820)
#include <Windows.h>
#include <tchar.h>
#include <MsiQuery.h>
#include <Shlwapi.h>
#pragma warning(pop)

static BOOL GetIniFilename(LPCTSTR pszKey, LPTSTR pszPath, DWORD cchMax)
{
    static const TCHAR szIni[] = TEXT("\\TOOLS.INI");
    DWORD dwType, dwSize;
    HKEY hKey1, hKey2;
    BOOL ret = FALSE;

    if(ERROR_SUCCESS == (RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall"), 0, STANDARD_RIGHTS_READ | KEY_QUERY_VALUE, &hKey1)))
    {
        if(ERROR_SUCCESS == RegOpenKeyEx(hKey1, pszKey, 0, STANDARD_RIGHTS_READ | KEY_QUERY_VALUE, &hKey2))
        {
            dwSize = cchMax * sizeof(*pszPath);

            if(ERROR_SUCCESS == RegQueryValueEx(hKey2, TEXT("LastInstallDir"), NULL, &dwType, reinterpret_cast<BYTE*>(pszPath), &dwSize))
            {
                if(dwType == REG_SZ)
                {
                    dwSize = min(dwSize / sizeof(*pszPath), cchMax - 1);
                    pszPath[dwSize] = TEXT('\0');

                    if((dwSize + lstrlen(szIni)) < cchMax)
                        ret = PathAppend(pszPath, szIni);
                }
            }

            RegCloseKey(hKey2);
        }
        RegCloseKey(hKey1);
    }

    return(ret);
}

static BOOL RegisterAgdiDriverWorker(LPCTSTR pszIniFilename, LPCTSTR pszDriver)
{
    TCHAR szItem[MAX_PATH * 3];
    TCHAR szKey[32];
    unsigned idx;

    for(idx = 0; idx < 1024; ++idx)
    {
        szItem[0] = TEXT('\0');
        wsprintf(szKey, TEXT("TDRV%u"), idx);
        GetPrivateProfileString(TEXT("C51"), szKey, TEXT(""), szItem, _countof(szItem), pszIniFilename);

        if(!szItem[0])
            break;

        if(StrStr(szItem, TEXT("SmartICE04.dll")))
            break;
    }

    if(idx >= 1024)
        return(FALSE);

    if(0 > wnsprintf(szItem, _countof(szItem), TEXT("%s (\"SmartICE04 Driver\")"), pszDriver))
        return(FALSE);

    szItem[_countof(szItem) - 1] = TEXT('\0');
    return(WritePrivateProfileString(TEXT("C51"), szKey, szItem, pszIniFilename));
}

UINT WINAPI RegisterAgdiDriver(MSIHANDLE hInstall)
{
    TCHAR szDriver[MAX_PATH * 2];
    TCHAR szIniFilename[MAX_PATH * 2];
    DWORD dw = _countof(szDriver);

    if(ERROR_SUCCESS == MsiGetProperty(hInstall, TEXT("ARPINSTALLLOCATION"), szDriver, &dw))
    {
        if(PathAppend(szDriver, TEXT("SmartICE04.dll")))
        {
            PathQuoteSpaces(szDriver);

            if(GetIniFilename(TEXT("Keil Vision3"), szIniFilename, _countof(szIniFilename)))
                RegisterAgdiDriverWorker(szIniFilename, szDriver);

            if(GetIniFilename(TEXT("Keil Vision4"), szIniFilename, _countof(szIniFilename)))
                RegisterAgdiDriverWorker(szIniFilename, szDriver);
        }
    }

    return(ERROR_SUCCESS);
}

#ifndef _DEBUG
EXTERN_C BOOL WINAPI _DllMainCRTStartup(HANDLE, DWORD, LPVOID)
{
	return TRUE;
}
#endif
