; Target: CC253x
; Purpose: Blink LEDs connected to P0.0 and P1.1 as on the USB dongle (see swru221a.pdf)
;
$NOMOD51

PCON            DATA    087h
P0              DATA    080h
P1              DATA    090h
ST0             DATA    095h
ST1             DATA    096h
ST2             DATA    097h
IEN0            DATA    0A8h
SLEEPCMD        DATA    0BEh
P0DIR           DATA    0FDh
P1DIR           DATA    0FEh
STIF            BIT     0C7h

                CSEG    AT 00000h
                clr     P1.0
                clr     A
                mov     R2, A
                mov     R1, #080h
                mov     ST2, A
                mov     ST1, #080h
                mov     ST0, A
                mov     SLEEPCMD, #006h
                mov     P0DIR, #001h
                mov     P1DIR, #003h
                mov     IEN0, #0A0h
Loop:           orl     PCON, #001h
                sjmp    Loop

                CSEG    AT 0002Bh
                clr     STIF
                cpl     P0.0
                jnb     P0.0, Done
                cpl     P1.1
Done:           mov     A, R1
                add     A, #080h
                mov     R1, A
                mov     ST1, R1
                clr     A
                addc    A, R2
                mov     R2, A
                mov     ST2, A
                mov     ST0, #000h
                reti

                END
