#include "precomp.h"

code const BYTE gc_ReportDescriptor[] =
{
    0x06, 0x00, 0xFF,              // USAGE_PAGE (Vendor Defined Page 1)
    0x09, 0x01,                    // USAGE (Vendor Usage 1)
    0xA1, 0x01,                    // COLLECTION (Application)

    0x85, 0x01,                    //   REPORT_ID (1)
    0x09, 0x0C,                    //   USAGE (Vendor Usage 0x0C)
    0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x01,                    //     USAGE (Vendor Usage 0x01)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT1),         //     REPORT_COUNT (sizeof(REPORT1))
    0x81, 0x02,                    //     INPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0x85, 0x02,                    //   REPORT_ID (2)
    0x09, 0x0D,                    //   USAGE (Vendor Usage 0x0D)
	0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x02,                    //     USAGE (Vendor Usage 0x02)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT2),         //     REPORT_COUNT (sizeof(REPORT2))
    0x91, 0x02,                    //     OUTPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0x85, 0x03,                    //   REPORT_ID (3)
    0x09, 0x0E,                    //   USAGE (Vendor Usage 0x0E)
	0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x02,                    //     USAGE (Vendor Usage 0x02)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT3),         //     REPORT_COUNT (sizeof(REPORT3))
    0x91, 0x02,                    //     OUTPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0x85, 0x04,                    //   REPORT_ID (4)
    0x09, 0x0F,                    //   USAGE (Vendor Usage 0x0F)
    0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x03,                    //     USAGE (Vendor Usage 0x03)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT4),         //     REPORT_COUNT (sizeof(REPORT4))
    0x91, 0x02,                    //     OUTPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0x85, 0x04,                    //   REPORT_ID (4)
    0x09, 0x10,                    //   USAGE (Vendor Usage 0x10)
	0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x03,                    //     USAGE (Vendor Usage 0x03)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT4),         //     REPORT_COUNT (sizeof(REPORT4))
    0x81, 0x02,                    //     INPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0x85, 0x05,                    //   REPORT_ID (5)
    0x09, 0x11,                    //   USAGE (Vendor Usage 0x11)
    0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x01,                    //     USAGE (Vendor Usage 0x01)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT5),         //     REPORT_COUNT (sizeof(REPORT5))
    0x81, 0x02,                    //     INPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0x85, 0x06,                    //   REPORT_ID (6)
    0x09, 0x12,                    //   USAGE (Vendor Usage 0x12)
    0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x01,                    //     USAGE (Vendor Usage 0x01)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT6),         //     REPORT_COUNT (sizeof(REPORT6))
    0x81, 0x02,                    //     INPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0x85, 0x07,                    //   REPORT_ID (7)
    0x09, 0x13,                    //   USAGE (Vendor Usage 0x13)
    0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x01,                    //     USAGE (Vendor Usage 0x01)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT7),         //     REPORT_COUNT (sizeof(REPORT7))
    0x81, 0x02,                    //     INPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0x85, 0x07,                    //   REPORT_ID (7)
    0x09, 0x13,                    //   USAGE (Vendor Usage 0x13)
    0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x01,                    //     USAGE (Vendor Usage 0x01)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT7),         //     REPORT_COUNT (sizeof(REPORT7))
    0x91, 0x02,                    //     OUTPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0x85, 0x08,                    //   REPORT_ID (8)
    0x09, 0x13,                    //   USAGE (Vendor Usage 0x13)
    0xA1, 0x02,                    //   COLLECTION (Logical)
    0x09, 0x01,                    //     USAGE (Vendor Usage 0x01)
    0x15, 0x00,                    //     LOGICAL_MINIMUM (0)
    0x26, 0xFF, 0x00,              //     LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //     REPORT_SIZE (8)
    0x95, sizeof(REPORT8),         //     REPORT_COUNT (sizeof(REPORT8))
    0x81, 0x02,                    //     INPUT (Data,Var,Abs)
    0xC0,                          //   END_COLLECTION

    0xC0                           // END_COLLECTION
};

code const DEVICE_DESCRIPTOR gc_DeviceDescriptor =
{
    sizeof(DEVICE_DESCRIPTOR),      /* bLength              */
    USB_DT_DEVICE,                  /* bDescriptorType      */
    IMPL_TO_LENDIAN(0x0200),        /* bcdUSB               */
    0,                              /* bDeviceClass         */
    0,                              /* bDeviceSubClass      */
    0,                              /* bDeviceProtocol      */
    EP0_PACKET_SIZE,                /* bMaxPacketSize0      */
    IMPL_TO_LENDIAN(0x14AB),        /* idVendor             */
    IMPL_TO_LENDIAN(0xCC11),        /* idProduct            */
    IMPL_TO_LENDIAN(0x0100),        /* bcdDevice            */
    1,                              /* iManufacturer        */
    2,                              /* iProduct             */
    3,                              /* iSerialNumber        */
    1                               /* bNumConfigurations   */
};

code const CONFIGURATION_DESCRIPTOR_COMPLETE gc_ConfigurationDescriptor =
{
    {
        sizeof(CONFIGURATION_DESCRIPTOR),       /* bLength              */
        USB_DT_CONFIGURATION,                   /* bDescriptorType      */
        IMPL_TO_LENDIAN(sizeof(CONFIGURATION_DESCRIPTOR_COMPLETE)), /* wTotalLength */
        1,                                      /* bNumInterfaces       */
        1,                                      /* bConfigurationValue  */
        0,                                      /* iConfiguration       */
        0xC0,                                   /* bmAttributes         */
        0x32                                    /* bMaxPower            */
    },
    {
        sizeof(INTERFACE_DESCRIPTOR),           /* bLength              */
        USB_DT_INTERFACE,                       /* bDescriptorType      */
        0,                                      /* bInterfaceNumber     */
        0,                                      /* bAlternateSetting    */
        2,                                      /* bNumEndpoints        */
        USB_CLASS_HID,                          /* bInterfaceClass      */
        USB_SUBCLASS_UNDEFINED,                 /* bInterfaceSubClass   */
        0,                                      /* bInterfaceProtocol   */
        0                                       /* iInterface           */
    },
    {
        sizeof(HID_DESCRIPTOR),                 /* bLength              */
        USB_DT_HID,                             /* bDescriptorType      */
        IMPL_TO_LENDIAN(0x0111),                /* bcdHID               */
        0,                                      /* bCountryCode         */
        1,                                      /* bNumDescriptors      */
        USB_DT_REPORT,                          /* bDescriptorType      */
        IMPL_TO_LENDIAN(sizeof(gc_ReportDescriptor))    /* wDescriptorLength    */
    },
    {
        {
            sizeof(ENDPOINT_DESCRIPTOR),        /* bLength              */
            USB_DT_ENDPOINT,                    /* bDescriptorType      */
            0x81,                               /* bEndpointAddress     */
            0x03,                               /* bmAttributes         */
            IMPL_TO_LENDIAN(EP1_PACKET_SIZE),   /* wMaxPacketSize       */
            0x02                                /* bInterval            */
        },
        {
            sizeof(ENDPOINT_DESCRIPTOR),        /* bLength              */
            USB_DT_ENDPOINT,                    /* bDescriptorType      */
            0x02,                               /* bEndpointAddress     */
            0x03,                               /* bmAttributes         */
            IMPL_TO_LENDIAN(EP2_PACKET_SIZE),   /* wMaxPacketSize       */
            0x01                                /* bInterval            */
        }
    }
};

code const BYTE code gc_String0Descriptor[] =
{
   0x04, USB_DT_STRING, 0x09, 0x04
};

code const BYTE code gc_String1Descriptor[] =
{
   sizeof("Technisches Buero Koenig") * 2, USB_DT_STRING,
   'T', 0,
   'e', 0,
   'c', 0,
   'h', 0,
   'n', 0,
   'i', 0,
   's', 0,
   'c', 0,
   'h', 0,
   'e', 0,
   's', 0,
   ' ', 0,
   'B', 0,
   'u', 0,
   'e', 0,
   'r', 0,
   'o', 0,
   ' ', 0,
   'K', 0,
   'o', 0,
   'e', 0,
   'n', 0,
   'i', 0,
   'g', 0
};

code const BYTE code gc_String2Descriptor[] =
{
   sizeof("SmartICE04") * 2, USB_DT_STRING,
   'S', 0,
   'm', 0,
   'a', 0,
   'r', 0,
   't', 0,
   'I', 0,
   'C', 0,
   'E', 0,
   '0', 0,
   '4', 0,
};

code const BYTE code* const gc_StringDescriptors[] =
{
   gc_String0Descriptor,
   gc_String1Descriptor,
   gc_String2Descriptor,
   gc_SerialNumberDescriptor
};
