#ifndef CENUMCONNECTIONS_H
#define CENUMCONNECTIONS_H

class CEnumConnections : public IEnumConnections
{
public:
    //IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    STDMETHOD(Next)(THIS_ ULONG cConnections, CONNECTDATA* ppData, ULONG* pcFetched);
    STDMETHOD(Skip)(THIS_ ULONG cConnections);
    STDMETHOD(Reset)(THIS);
    STDMETHOD(Clone)(THIS_ IEnumConnections** ppEnum);

    __checkReturn HRESULT Add(__in IUnknown* pUnknown) throw();

    CEnumConnections(class CConnectionPoint* pItf) throw();

private:
    virtual ~CEnumConnections() throw();
    CEnumConnections(const CEnumConnections&);
    CEnumConnections& operator=(const CEnumConnections&);

    class CConnectionPoint* m_pItf;
    volatile ULONG_PTR      m_lCursor;
    ULONG                   m_lRefCount;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

#endif