#ifndef CSMARTICE04PROGRESSDUMMY_H
#define CSMARTICE04PROGRESSDUMMY_H

class CSmartICE04ProgressDummy : public ISmartICE04Progress, public IDispatch
{
public:
    // IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObejct);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    // ISmartICE04Progress
    STDMETHOD(Start)(THIS);
    STDMETHOD(Stop)(THIS);
    STDMETHOD(SetProgress)(THIS_ long lCompleted, long lTotal);
    STDMETHOD(get_Canceled)(THIS_ VARIANT_BOOL* pblCanceled);

    // IDispatch
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT*);
    STDMETHOD(GetTypeInfo)(THIS_ UINT, LCID, ITypeInfo**);
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID, LPOLESTR*, UINT, LCID, DISPID*);
    STDMETHOD(Invoke)(THIS_ DISPID, REFIID, LCID, WORD, DISPPARAMS*, VARIANT*, EXCEPINFO*, UINT*);

    VOID SetDispatch(IDispatch* pDispatch);

    CSmartICE04ProgressDummy();
    virtual ~CSmartICE04ProgressDummy();

private:
    HRESULT GetProperty(LPWSTR pwszName, VARIANT* rgvarg);
    HRESULT GetProperty(LPWSTR pwszName, VARIANT_BOOL* pval);
    HRESULT InvokeMethod(LPWSTR pwszName, VARIANT* rgvarg = NULL, UINT cArgs = 1, VARIANT* pVarResult = NULL);

    IDispatch*  m_pDispatch;
};

#endif