#ifndef CCURSOR_H
#define CCURSOR_H

class CCursor
{
public:
    CCursor(LPCTSTR lpCursorName) : m_lpCursorName(lpCursorName) { m_hCursor = ::SetCursor(::LoadCursor(NULL, lpCursorName)); }
    ~CCursor() { ::SetCursor(m_hCursor); }

    VOID Refresh() { ::SetCursor(::LoadCursor(NULL, m_lpCursorName)); }

private:
    LPCTSTR m_lpCursorName;
    HCURSOR m_hCursor;
};

#endif